////////////////////////////////////////////////////
//
//	IMAGE.H: Class declarations for images
//
//

//	This library is free software; you can redistribute it and/or
//	modify it under the terms of the GNU Library General Public
//	License as published by the Free Software Foundation; either
//	version 2 of the License, or (at your option) any later version.
//
//	This library is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//	Library General Public License for more details.
//
//	You should have received a copy of the GNU Library General Public
//	License along with this library; if not, write to the Free
//	Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


typedef unsigned char	pxl_t;	// "Pixel Component"
typedef enum {FALSE = 0, TRUE = 1} Boolean;

class Image {
public:
	virtual int width(void) const = 0;	// Returns width of image
	virtual int height(void) const = 0;	// Returns height of image
	virtual int rowsLeft(void) const = 0;// Returns number of rows remaining
	virtual void getRow(pxl_t *Whither) = 0;// Writes a row to location Whither
	inline Boolean isFull(void) const
		{ return Boolean(rowsLeft() == abs(height())); };
		// indicates whether all rows of image are still available.
};
