///////////////////////////////////////////////////
//
//	ZOOM.H  Declarations for zoomed images
//
//

//	This library is free software; you can redistribute it and/or
//	modify it under the terms of the GNU Library General Public
//	License as published by the Free Software Foundation; either
//	version 2 of the License, or (at your option) any later version.
//
//	This library is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//	Library General Public License for more details.
//
//	You should have received a copy of the GNU Library General Public
//	License along with this library; if not, write to the Free
//	Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.



// requires "image.h"

typedef signed short	dpxl_t; //"Difference of Pixel Components"

class VZoom : public Image {
private:
	Image*		src;
	const int	widthDat;
	const int	heightDat;
	const int	srcHeight;
	int			rowsLeftDat;
	pxl_t*		buffers;
	pxl_t* 		cn_row;		// Row of C[n] values
	pxl_t*		cnP1_row;	// Row of C[n+1] values
	pxl_t* 		f2nP1_row;	// Row of F[2n+1] values
	pxl_t*		f2nM1_row;	// Row of F[2n-1] values
	dpxl_t*		lgD;		// Row of LogD[n] or LogD[n-1] values
	VZoom(void);

public:
	inline int	width(void) const { return widthDat; };
	inline int	height(void) const { return heightDat; };
	inline int	rowsLeft(void) const { return rowsLeftDat; };
	void 		getRow(pxl_t *Whither); // Writes a row to location Whither
	VZoom(Image &S);
	~VZoom();
	};

class HZoom : public Image {
private:
	Image*		src;
	const int	widthDat;
	const int	heightDat;
	const int	srcWidth;
	int			rowsLeftDat;
	pxl_t* 		c_row;	// Row of coarse values
	pxl_t* 		f_row;	// Row of fine values
	HZoom(void);

public:
	inline int	width(void) const { return widthDat; };
	inline int	height(void) const { return heightDat; };
	inline int	rowsLeft(void) const { return rowsLeftDat; };
	void 		getRow(pxl_t *Whither); // Writes a row to location Whither
	HZoom(Image &S); // Constructor
	~HZoom() {if (widthDat){delete [] c_row; delete [] f_row;}}; //Destructor
};

