////////////////////////////////////////////////////
//
//	ZOOMTEST.C: Test shell for image zoomer.
//
//

//	This library is free software; you can redistribute it and/or
//	modify it under the terms of the GNU Library General Public
//	License as published by the Free Software Foundation; either
//	version 2 of the License, or (at your option) any later version.
//
//	This library is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//	Library General Public License for more details.
//
//	You should have received a copy of the GNU Library General Public
//	License along with this library; if not, write to the Free
//	Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


#include <stdlib.h>
#include <iostream.h>
#include <fstream.h>
#include "image.h"
#include "bmp.h"
#include "zoom.h"

int main(int ArgC, char *ArgV[])
{
	
	if (ArgC != 3) {
		cerr << "Usage: ZOOMTEST <infile> <outfile>\n";
		exit(EXIT_FAILURE);
	}

	{
		ifstream 	InFile(ArgV[1], ios::in | ios::binary);
		ofstream 	OutFile(ArgV[2], ios::out | ios::binary);
		BmpFile		InImage(InFile);
		VZoom 		TallImage(InImage);
		HZoom 		BigImage(TallImage);
		BmpFileFromImage(OutFile,BigImage);
	}

	return 0;
}