/*
** @#START#@
**
**	Cage Controller OS Open Code
**
**	(C) Copyright International Business Machines Corporation 1997,1998
**	Licensed Material  -  Program Property of I B M 
**	Refer to copyright instructions: Form G120-2083
**
**  Module:
**	enetsave.h
**
** Description:
**	Defines for ethernet failover device driver
**
** Functions:
**
** Dependencies:
**
** Context:
**
** Restrictions:
**
** Environment:
**	OS Open 1.6.5 (XCOFF) on JDS-Box
**
** Linkage:
**	AIX 4.2.1 with CSet++ 3.1.4-8
**
** Entry points:
**
** External references:
**
** @author
**	Thomas Richter
**
** @version
**	$KW; $-FN; $-Ver; $-ChkD; $-Own; $EKW;
**
** History:
** Date      Author      Description
** --------------------------------------------------------------------------
** 23-Aug-99 Richter     Failover ethernet device driver
**
** @#END#@*/

#ifndef enetsave_h
#define enetsave_h

#ifdef __cplusplus
extern "C" {
#endif

/*
** Define message to be send between ethernet devices to propagate usage
** of alternate interface.
*/
struct ether_swapcmd {
    unsigned char sw_cmd;		/* Swap command */
    unsigned char sw_ifno;		/* Interface number to swap to */
};
struct ether_swap {
    struct ether_header eh;		/* Ethernet header */
    struct ether_swapcmd es;		/* Ethernet swap network */
};

#define	ETHERTYPE_SWAP		0x805	/* Ethernet swap interface message */
#define ETHERSWAP_USEIF		0x1	/* Ethernet swap interface cmd */
#define	ETHERSWAP_KEEPALIVE	0x2	/* Alternate ethernet reachable */

#ifdef __cplusplus
}
#endif
#endif
