<?php
/*
 * Session Management for PHP3
 *
 * (C) Copyright 1998 SH Online Dienst GmbH
 *                    Boris Erdmann, Kristian Koehntopp
 *
 * $Id: local.inc,v 1.1 1999/05/05 10:08:29 djr Exp $
 *
 */ 

class DB_Cyber extends DB_Sql {
  var $Host     = ""; 
  var $Database = "test";
  var $User     = "root";
  var $Password = "";
}

class Cyber_query extends db_form_query {
 
  var $database_class = "DB_Cyber";  		## Which database to connect..
  var $form_defs_table = "form_defs";  		## Form definition table 
  var $report_defs_table = "form_reports_defs";	## Report definition table
  var $reports_table = "form_reports"; 		## Reports table
  
  var $link = ""; ## If set then then each entry in the first column is linked, with key fields and values appended to the URL
  var $link_target = ""; 			## optional target window/frame for report out
  
  ## Format MySQL date
  function db_format_date($data)
  {  
    ereg("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})", $data, $regs );
    return $regs[3]."/".$regs[2]."/".$regs[1];
  }
}
  
class Cyber_edit extends db_form_edit {
  var $database_class = "DB_Cyber";  		## Which database to connect..
  var $form_defs_table = "form_defs";  		## Form definition table 
}

class Cyber_Session extends Session {
  var $classname = "Cyber_Session";

  var $cookiename     = "";                ## defaults to classname
  var $magic          = "Hocuspocus";      ## ID seed
  var $mode           = "cookie";          ## We propagate session IDs with cookies
  //var $fallback_mode  = "get";
  var $lifetime       = 0;                 ## 0 = do session cookies, else minutes
 
  var $database_class = "DB_Cyber";          ## Which database to connect...
  var $database_table = "active_sessions"; ## and find our session data in this table.

  var $gc_probability = 5;  
}

class Cyber_Auth extends Auth {
  var $classname      = "Cyber_Auth";

  var $lifetime       =  15;

  var $database_class = "DB_Cyber";
  var $database_table = "auth_user";
  
  function auth_loginform() {
    global $sess;
    include("loginform.ihtml");
  }
  
  function auth_validatelogin() {
    global $username, $password;

    $this->auth["uname"]=$username;        ## This provides access for "loginform.ihtml"
    
    $uid = false;

    $this->db->query(sprintf("select uid, perms
                                     from %s
                                    where username = '%s'
                                      and password = '%s'",

                          $this->database_table,
                          addslashes($username),
                          addslashes($password)));

    while($this->db->next_record()) {
      $uid = $this->db->f("uid");
      $this->auth["perm"] = $this->db->f("perms");
    }
    
    return $uid;
  }
}

class Cyber_Default_Auth extends Cyber_Auth {
  var $classname = "Cyber_Default_Auth";
  
  var $nobody    = true;
}

class Cyber_Challenge_Auth extends Auth {
  var $classname      = "Cyber_Challenge_Auth";

  var $lifetime       =  1;

  var $magic          = "Simsalabim";  ## Challenge seed
  var $database_class = "DB_Cyber";
  var $database_table = "auth_user";

  function auth_loginform() {
    global $sess;
    global $challenge;
    
    $challenge = md5(uniqid($this->magic));
    $sess->register("challenge");
    
    include("crloginform.ihtml");
  }
  
  function auth_validatelogin() {
    global $username, $password, $challenge, $response;

    $this->auth["uname"]=$username;        ## This provides access for "loginform.ihtml"
    $this->db->query(sprintf("select uid,perms,password ".
				"from %s where username = '%s'",
                          $this->database_table,
                          addslashes($username)));

    while($this->db->next_record()) {
      $uid   = $this->db->f("uid");
      $perm  = $this->db->f("perms");
      $pass  = $this->db->f("password");
    }
    $exspected_response = md5("$username:$pass:$challenge");

    ## True when JS is disabled
    if ($response == "") {
      if ($password != $pass) {
        return false;
      } else {
        $this->auth["perm"] = $perm;
        return $uid;
      }
    }
    
    ## Response is set, JS is enabled
    if ($exspected_response != $response) {
      return false;
    } else {
      $this->auth["perm"] = $perm;
      return $uid;
    }
  }
}

class Cyber_Perm extends Perm {
  var $classname = "Cyber_Perm";
  
  var $permissions = array(
                            "guest"      => 1,
                            "user"       => 3,
                            "admin"      => 7
                          );

  function perm_invalid($does_have, $must_have) {
    global $perm, $auth, $sess;
    
    include("perminvalid.ihtml");
  }
}
?>
