<?php
/*
 * db_form 
 *
 * The base class for db_forms
 *
 * db_forms is an extention of OOHforms (Copyright (c) 1998 by Jay Bloodworth) 
 *
 * By Darryl Ross 1999
 *
 * $Header
 *
 * djr@cyber.com.au
 *
 */

include("oohforms.inc");

# NB all db_forms functions are prepended with db to avoid conflict with OOHforms functions
class db_form extends form 
{
  var $database_class = "DB_Cyber";  ## Which database to connect..
  var $form_defs_table = "form_defs"; 
  var $data_table;
  var $db;                            ## Database Object
  var $form_name;
  var $key_fields; # An array of key fields for the table
  var $fields;

  # Displays the db_form elements in a table defined in the form definition
  # OK there is no table yet, but there will be one day :)
  function db_show_elements()
  {
    $current_row = 1; echo "<table><tr>\n";
    reset($this->fields);
    while (list($field, $form_defs) = each($this->fields)) 
    {
      if ($form_defs["html_type"] != "hidden")
      {
        if ($current_row != $form_defs["table_row"])
        {
          $current_row = $form_defs["table_row"];
	  echo "</tr><tr>\n";
        }
	$label = $form_defs["label"];
	if ($form_defs["html_type"] == "checkbox")
	{
	  $check_text = $label;
	  $label = "&nbsp";
	}

        $this->db_show_pre($label);
        echo "<td colspan=\"".$form_defs["colspan"]."\" rowspan=\"".$form_defs["rowspan"]."\">";
        $this->show_element($field);

	if ($form_defs["html_type"] == "checkbox")
          echo "<strong>$check_text</strong>";

        $this->db_show_post($form_defs["data_type"]);
        echo "</td>\n";
      }
    }
    echo "</tr></table>";
  }

  # Displays anything that goes before a field (eg a label)
  function db_show_pre($text)
  {
    if (strlen($text) > 0)
    {
      echo "<th align=\"right\">$text</th>";
    }
  }

  # Displays anything that goes after a field
  function db_show_post($type)
  {
  }

  # Basically does an ooh forms add_element() for each field in the definition
  function db_add_elements($def)
  { # Derive an instance of the database class
    eval("\$this->db = new ".$this->database_class.";");
    $this->form_name = $def;
    $this->db->query("SELECT * FROM $this->form_defs_table WHERE form_name = '$this->form_name' ORDER BY table_row, table_col");
    while ($this->db->next_record())
    {
      # plain text is treated as an ooh form frozen field
      if (($type = $this->db->f("html_type")) == "plain text")
      {
        $type = "text";
	$frozen[] = $this->db->f("field_name");
      }
      
      $el = array("type"=>$type,"name"=>$this->db->f("field_name"));
      switch ($type)
      {
	case "password" :
	  $el["pass"] = 1;
        case "text" :
          $el["size"] = $this->db->f("html_size"); $el["maxlength"] = $this->db->f("max_size");
	break;

	case "select" :
	  $el["options"] = $this->db_select_options($this->db->f("lookup"));
	break;

	case "textarea" :
	  $el["rows"] = $this->db->f("rowspan"); $el["cols"] = $this->db->f("colspan");
	break;

	case "radio" :
	  # To be filled in when I work out what to do
	break;
      }

      $el["value"] = $this->db->f("default_value");

#for (reset($el); $key = key($el); next($el))
#echo "$key=>$el[$key] ";
#echo "<br>\n";

      $this->add_element($el);

      $this->fields[$this->db->f("field_name")] = array("label"=>$this->db->f("label"),"table_row"=>$this->db->f("table_row"),
      	"table_col"=>$this->db->f("table_col"), "data_type"=>$this->db->f("data_type"),"html_type"=>$this->db->f("html_type"),
	"rowspan"=>$this->db->f("rowspan"), "colspan"=>$this->db->f("colspan"), "key_field"=>$this->db->f("key_field"),
	"required"=>$this->db->f("required"), "perms"=>$this->db->f("perms"));
      if ($this->db->f("key_field"))
        $this->key_fields[] = $this->db->f("field_name");
    }
    $this->db->query("SELECT table_name FROM forms WHERE form_name = '$this->form_name'");
    $this->db->next_record();
    $this->data_table = $this->db->f("table_name");

    # Freeze any frozen (plain text) fields
    if (is_array($frozen))
      $this->freeze($frozen);
  }

  # Derives a options for a select element from either an SQL query or a comma seperated list
  function db_select_options($lookup)
  {
     # This is real lame ('cause my regex sucks at the moment ;-)
     if (ereg("(SELECT).|(select ).",$lookup,$reg))
     {
       $this->db->query($lookup);
       # Assumes that if query returns more than 1 field that the 1st is the label and the 2nd the value
       if ($this->db->num_fields() > 1)
         while (!$this->db->next_record())
           $options[] = array("label"=>$this->db->f(0),"value"=>$this->db->f(1));
       else
         while (!$this->db->next_record())
           $options[] = $this->db->f(0);
     }
     else
     { # If first field is blank then labels,value else a list of labels 
       $buffer = split(",",$lookup,100);
       if ($buffer[0] == "")
         for ($i = 1; $i < count($buffer)-1; $i+=2)
	   $options[] = array("label"=>$buffer[$i],"value"=>$buffer[$i+1]);

       else
         $options = $buffer;
     }

     return $options;
  }

  # Format the data. The functions called by this function should be overloaded to meet site specific conditions
  function db_format($data, $type)
  {
    switch ($type)
    {
      case "text" :
        return $this->db_format_text($data);
      case "number" :
        return $this->db_format_number($data);
      case "money" :
        return $this->db_format_money($data);
      case "date" :
        return $this->db_format_date($data);
      default :
        return $data;
    }
  }

  function db_format_text($data)
  {
    return $data;
  }

  function db_format_number($data)
  {
    return $data;
  }
  
  function db_format_money($data)
  {
    return $data;
  }

  function db_format_date($data)
  {
    return $data;
  }

}
?>
