<?php

class db_form_edit extends db_form 
{

  # Uses the table keys to get the data for the record from the database. Assigns the data to the html variables, and
  # then calls OOHforms load_defaults to load the data into the form elements.
  function db_load_defaults()
  {
    reset($this->key_fields);
    while (list($key, $field) = each($this->key_fields)) 
    {
      global $$field;
      if (isset($query))
        $query .= " AND ";
      $query .= "$field = '".$$field."'";
    }
    $query = "SELECT * FROM $this->data_table WHERE $query";
    $this->db->query($query);
    while ($this->db->next_record()) 
    {
      reset($this->fields);
      while (list($field, $form_defs) = each($this->fields)) 
      {
        if (!$form_defs["key_field"]) global $$field;
	$$field = $this->db->f($field);
      }
    }
    $this->load_defaults();
  }

  # Inserts the db_form element values into the database, returns true on success
  function db_insert()
  {
    reset($this->fields);
    while (list($field, $form_defs) = each($this->fields)) 
    {
      if (!isset($fields))
        $fields = $field;
      else
        $fields .= ", $field";
      # A variable variable to access the html form values
      global $$field;

      # Set unchecked checkboxes to 0 
      if ($form_defs["html_type"] == "checkbox" && !isset($$field))
        $$field = "0";

      # Convert empty fields to null, so that they don't sneak into the database
      $value = $this->db_format($$field, $form_defs["data_type"]);
      $value = (strlen($value) == 0) ? "null" : $value;
      if ($form_defs["key_field"] && $value == "null")
        return 0;
      if (!isset($values))
        $values = ($value == "null") ? "$value" : "'$value'";
      else
        $values .= ($value == "null") ? ",$value" : ",'$value'";
    }
#echo"INSERT INTO $this->data_table ($fields) VALUES($values)<br>\n" ;
    $this->db->query("INSERT INTO $this->data_table ($fields) VALUES($values)");
#return 0;
    return $this->db->affected_rows(); 
  }

  # Updates the db_form element values in the database, returns true on success
  function db_update()
  {
    reset($this->fields);
    while (list($field, $form_defs) = each($this->fields)) 
    {
      global $$field;

      # Set unchecked checkboxes to 0 
      if ($form_defs["html_type"] == "checkbox" && !isset($$field))
        $$field = "0";

      # Assume empty fields are null
      $value = $this->db_format($$field, $form_defs["data_type"]);
      $value = (strlen($value) == 0) ? "null" : $value;
      if ($form_defs["key_field"])
      {
        if ($value == "null")
	  return 0;
        if (!isset($keys))
          $keys = "$field = '$value'";
        else
          $keys .= " AND $field = '$value'";
      }
      else
        if (!isset($fields))
          $fields = "$field = ".(($value == "null") ? "$value" : "'$value'");
        else
          $fields .= ",$field = ".(($value == "null") ? "$value" : "'$value'");
    }
#echo"UPDATE $this->data_table SET $fields WHERE $keys" ;
    $this->db->query("UPDATE $this->data_table SET $fields WHERE $keys");
#return 0;
#echo $this->db->affected_rows()." rows affected<br>";
    return $this->db->affected_rows(); 
  }

}
?>
