<?php
/*
 * db_form_query 
 *
 * The query class for db_forms
 *
 * db_forms is an extention of OOHforms (Copyright (c) 1998 by Jay Bloodworth) 
 *
 * By Darryl Ross 1999
 *
 * $Header
 *
 * djr@cyber.com.au
 *
 */


class db_form_query extends db_form 
{
  var $report_defs_table = "form_reports_defs"; 
  var $reports_table = "form_reports"; 
  var $report_labels;
  var $report_width;
  var $delimiter;
  var $upload_fieldnames = false;
  
  var $link = ""; # If set then then each entry in the first column is linked, with key fields and values appended to the URL
  var $link_target = "";
  
  # Queries the data_table and returns the number of records found 
  function db_search($report = "")
  {
    reset($this->fields);
    unset($this->report_labels);
    while (list($field, $form_defs) = each($this->fields)) 
    {
      # If there is no report then use the form labels as report labels
      if (strlen($report) == 0)
      {
	 if ($form_defs["required"])
	 {
           if (!isset($query))
             $query = "SELECT ".$field;
           else
             $query .= ",".$field;
	   $this->report_labels[] = array("label"=>$form_defs["label"], "width"=>$form_defs["html_size"]);
	 }
      } 
      
      # A variable variable to access the html form values
      global $$field;

      if (!$form_defs["required"])
      {
        if (strlen($$field) > 0)
          if (!isset($lselect))
            $lselect = "$field = '".$$field."'";
          else
            $lselect .= " AND $field = '".$$field."'";
      }
      else
      {
        # Only include fields which have data in the where clause
        if (strlen($$field) > 0)
          if (!isset($select))
            $select = "$field like '".$$field."%'";
          else
            $select .= "AND $field like '".$$field."%'";
      }

    }

    # Get the query fields and labels from the report def
    # NB width has not been implemented yet
    if (strlen($report) > 0)
    {
      $this->db->query("SELECT * FROM $this->report_defs_table WHERE report_name = '$report' ORDER BY table_col"); 
      while ($this->db->next_record())
      {
        if (!isset($query))
          $query = "SELECT ".$this->db->f("field_name");
        else
          $query .= ",".$this->db->f("field_name");
	$this->report_labels[] = array("label"=>$this->db->f("label"), "type"=>$this->db->f("format_type"));
      }
      $this->db->query("SELECT * FROM $this->reports_table WHERE report_name = '$report'"); 
      $this->db->next_record();
      $this->report_width = $this->db->f("report_width");
    }

    # Don't query the database if nothing was entered (or else it will return all records)
    if (isset($select))
    {
      $query .= " FROM $this->data_table WHERE $select";
      if (isset($lselect))
        $query .= " AND $lselect";
#echo $query."<br>";
      $this->db->query($query);
      return $this->db->num_rows();
    }
    else
    {
      return 0;
    }
  }

  # Display the search results for current query. 
  # Results are displayed in a fixed format table. Latter it is hoped to 
  # use CSS, but this has not been done yet because many places still have
  # old browsers which don't support this.
  function db_search_results()
  {
    echo "<table border=\"1\" width=\"".$this->report_width."%\">\n<tr>\n";
    while (list($key, $report_defs) = each($this->report_labels))
      echo "<th align=\"left\">".$report_defs["label"]."</th>\n";

    while ($this->db->next_record())
    {
      echo "</tr>\n<tr>\n";
      for ($i = 0; $i < $this->db->num_fields(); $i++)
      {
        echo "<td>";
	if ($i == 0 && isset($this->link))
	{
	  echo "<a href = \"".$this->link;
          reset($this->key_fields);
          while (list($key, $field) = each($this->key_fields)) 
          {
	    echo "&$field=".urlencode(trim($this->db->f($field)));
	  }
	  echo "\" target = \"$this->link_target\">";
	}
	echo $this->db_format($this->db->f($i), $this->report_labels[$i]["type"]);
	if ($i == 0 && isset($this->link))
	  echo "</a>";
	echo "</td>\n";
      }
    }
      
    echo "</tr>\n</table>";
  }

}
?>
