CREATE TABLE forms (
	form_name varchar(50) NOT NULL,
	table_name varchar(50) NOT NULL,
	PRIMARY KEY (form_name)
	);

CREATE TABLE form_defs (
	form_name varchar(50) NOT NULL,
	field_name varchar(50) NOT NULL,
	label varchar(80) NOT NULL,
	table_row integer NOT NULL,
	table_col integer NOT NULL,
	data_type varchar(80) NOT NULL,
	html_type varchar(20) NOT NULL,
	html_size integer,
	max_size integer,
	rowspan integer NOT NULL DEFAULT 1,
	colspan integer NOT NULL DEFAULT 1,
	key_field integer NOT NULL,
	required integer NOT NULL,
	default_value varchar(80),
	e_validate varchar(80),
	s_validate varchar(80),
	lookup varchar(255),
	permissions varchar(50),
	PRIMARY KEY (form_name, field_name)
	);

CREATE TABLE form_reports (
	report_name varchar(50) NOT NULL,
	form_name varchar(50) NOT NULL,
	report_type varchar(20) NOT NULL,
	delimiter varchar(10) DEFAULT ',',
	download_field_names integer NOT NULL DEFAULT 0,
	report_width integer NOT NULL DEFAULT 100,
	PRIMARY KEY (report_name)
	);

CREATE TABLE form_reports_defs (
	report_name varchar(50) NOT NULL,
	field_name varchar(50) NOT NULL,
	label varchar(80) NOT NULL,
	table_col integer NOT NULL,
	format_type varchar(20) NOT NULL DEFAULT 'text',
	PRIMARY KEY (report_name, field_name)
	);
