#include <stdio.h>

#define X 0
#define Y 1

#define TRUE	1
#define FALSE	0

int PointInTriangle( tri, point )
double  tri[3][2] ;
double  point[2] ;
{
    double x0, x1, x2, y1, u, v, denom ;
    x1 = tri[1][X] - tri[0][X] ;

    if ( x1 == 0.0 ) {

        /* triangle points 0 and 1 have the same X value */

        /* zero area test - can be removed if triangle is
         * known to be valid
         */
		x2 = tri[2][X] - tri[0][X] ;
        if ( ( x2 == 0.0 ) ||

            /* compute u and check bounds */
            ( ( u = (point[X] - tri[0][X]) / x2 ) < 0.0 ) ||
            ( u > 1.0 ) ||

            /* zero area test - remove if known to be valid */
            ( ( y1 = tri[1][Y] - tri[0][Y] ) == 0.0 ) ||

            /* compute v and check bounds */
            ( ( v = ( (point[Y] - tri[0][Y]) - u *
                ( tri[2][Y] - tri[0][Y] ) ) / y1 ) < 0.0 ) ) {

                /* missed for some reason */
                return FALSE ;
        }

    } else {
        /* triangle points 0 and 1 have a different X value */

        /* compute denom and check for zero area triangle - check
         * is not needed if triangle known to be valid.
         */
        x2 = tri[2][X] - tri[0][X] ;
        y1 = tri[1][Y] - tri[0][Y] ;
        denom = ( tri[2][Y] - tri[0][Y] ) * x1 - x2 * y1 ;
        if ( ( denom == 0.0 ) ||

            /* compute u and check bounds */
            ( ( u = ( (point[Y] - tri[0][Y]) * x1 - (x0 = point[X] - tri[0][X]) * y1 ) / denom ) < 0.0 ) ||
            ( u > 1.0 ) ||

            /* compute v & check bounds */
            ( ( v = ( x0 - u * x2 ) / x1 ) < 0.0 ) ) {

                /* missed for some reason */
                return FALSE;
        }
    }

    /* check gamma */
    if ( u + v > 1.0 ) {
        /* outside third edge */
        return FALSE ;
    }

    return( TRUE ) ;
}

void test_grid( xlo, xhi, ylo, yhi, tri )
int xlo ;
int xhi ;
int ylo ;
int yhi ;
double tri[3][2] ;
{
	double pt[2] ;
	int x,y;

	printf("\nFor triangle (%g,%g),(%g,%g),(%g,%g):\n",
		(float)tri[0][X],(float)tri[0][Y],
		(float)tri[1][X],(float)tri[1][Y],
		(float)tri[2][X],(float)tri[2][Y] ) ;

	for ( y = yhi ; y >= ylo ; y-- ) {
		printf( "%2d  ",y) ;
		for ( x = xlo ; x <= xhi ; x++ ) {
			pt[X] = (double)x ;
			pt[Y] = (double)y ;

			if ( PointInTriangle( tri, pt ) == TRUE ) {
				printf("**") ;
			} else {
				printf("..") ;
			}
		}
		printf("\n") ;
	}
	printf("    %2d",xlo) ;
	for ( x = xlo+1 ; x < xhi ; x++ ) {
		printf("--");
	}
	printf("%2d\n\n",xhi) ;
}

main( argc, argv )
int argc;
char **argv;
{
	double tri1[3][2] = { {5.0,5.0},{5.0,10.0}, {11.0,6.0} } ;	/* x0 & x1 match */
	double tri2[3][2] = { {5.0,5.0},{6.0,10.0}, {11.0,4.0} } ;
	double tri3[3][2] = { {4.1,9.7},{4.0,8.3}, {12.4,9.0} } ;	/* isoceles */
	double tri4[3][2] = { {3.0,3.2},{3.0,9.22}, {13.0,8.7} } ;	/* x0 & x1 match */
	double tri5[3][2] = { {7.6,7.0},{3.1,3.4}, {11.2,11.6} } ;
	double tri6[3][2] = { {5.2,3.4},{9.2,4.3}, {13.0,5.1} } ;	/* sliver - none hit */

	test_grid( 0, 15, 0, 15, tri1 ) ;
	test_grid( 0, 15, 0, 15, tri2 ) ;
	test_grid( 0, 15, 0, 15, tri3 ) ;
	test_grid( 0, 15, 0, 15, tri4 ) ;
	test_grid( 0, 15, 0, 15, tri5 ) ;
	test_grid( 0, 15, 0, 15, tri6 ) ;
}
